#property copyright "Integer"
#property link      "for-good-letters@yandex.ru"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 2
#property indicator_buffers 2


#property indicator_color1 Red
#property indicator_color2 Yellow

#property indicator_width1 2
#property indicator_width2 2

//---- input parameters
extern bool ShowHelp=false;
extern int Aspect=0; 
extern int MovingPlanet=2;
extern int MovingTimeShiftMinutes=0;
extern int StaticPlanet=0;
extern int StaticTimeShiftMinutes=0;

extern color Col=Khaki;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

double Ugol[];
string PlName[]={"","","","","","","","","","","","","","","","",""};

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){
//---- indicators

   if(ShowHelp){
      string str="Planet:\n";
      for(int i=0;i<ArraySize(PlName);i++){
         str=str+i+" - "+PlName[i]+"\n";
      }
      Comment(str);
      
   }


   IndicatorBuffers(3);

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,ExtMapBuffer1);
   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,ExtMapBuffer2);   
   
   
   SetIndexLabel(0,"Direct Aspect");
   SetIndexLabel(1,"Retrograd Aspect");   
   
   
   IndicatorShortName(PlName[MovingPlanet]+"("+MovingPlanet+")"+" - "+PlName[StaticPlanet]+"("+StaticPlanet+")"+" - "+Aspect);

   
   IndicatorDigits(0);
   
   SetIndexStyle(2,DRAW_ARROW);   
   SetIndexBuffer(2,Ugol);   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment(""); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){
               ExtMapBuffer1[i]=EMPTY_VALUE;
               ExtMapBuffer2[i]=EMPTY_VALUE;               
               double mpl1=iCustom(NULL,0,"ind_Astro_Ephemerid_v1",false,MovingPlanet,MovingTimeShiftMinutes,Col,0,i);
               double spl1=iCustom(NULL,0,"ind_Astro_Ephemerid_v1",false,StaticPlanet,StaticTimeShiftMinutes,Col,0,i);

               Ugol[i]=mpl1-spl1;
               
                  if(Ugol[i]<0){
                     Ugol[i]+=360;
                  }               
               
               double CurUgol=Ugol[i];
               double PreUgol=Ugol[i+1];                  
               
                  if(CurUgol-PreUgol>180)CurUgol-=360;
                  if(CurUgol-PreUgol<-180)PreUgol-=360;                  

                  if(CurUgol>=Aspect && PreUgol<Aspect){
                     ExtMapBuffer1[i]=1;
                  }
                  
                  if(CurUgol<=Aspect && PreUgol>Aspect){
                     ExtMapBuffer2[i]=1;
                  }                  
            }
   return(0);
  }
//+------------------------------------------------------------------+